using System;
   internal class Program
   {
       class Tacka
       {
           private int x;
           private int y;

           public Tacka()
           {
               x = 0;
               y = 0;
           }
           public Tacka(int a, int b)
           {
               x= a;
               y = b;
           }
           public int X
           {
               set { x = value; }
               get { return x; }
           }
           public int Y
           {
               set { y = value; }
               get { return y; }
           }
       }
       class Trougao
       {
           Tacka A;
           Tacka B;
           Tacka C;

           public Trougao() { }
           public Trougao(Tacka D, Tacka E, Tacka F)
           {
               A = D;
               B = E;
               C = F;
           }
           public double Povrsina()
           {
               double s = Math.Abs(((A.X * B.Y) + (B.X * C.Y) + (C.X * A.Y) - ((A.Y * B.X) + (B.Y * C.X) + (C.Y * A.X)) / 2.0));
               return s;
           }
       }

       static void Main(string[] args)
       {
           int N = int.Parse(Console.ReadLine());
           int[] xkoor = new int[N];
           int[] ykoor = new int[N];

           for (int i = 0; i < N; i++)
           {
               string [] unos = Console.ReadLine().Split(" ");
               xkoor[i] = int.Parse(unos[0]);
               ykoor[i] = int.Parse(unos[1]);
           }

           Tacka A = new Tacka(xkoor[0], ykoor[0]);
           Tacka B = new Tacka(xkoor[1], ykoor[1]);
           Tacka C = new Tacka(xkoor[2], ykoor[2]);
           Tacka D = new Tacka(xkoor[3], ykoor[3]);

           Trougao T1 = new Trougao(A, B, C);
           Trougao T2 = new Trougao(A, B, D);
           Trougao T3 = new Trougao(B, C, D);
           Trougao T4 = new Trougao(A, C, D);

           double max1 = T1.Povrsina();
           Console.WriteLine(max1);
           double max2 = T2.Povrsina();
           Console.WriteLine(max2);
           double max3 = T3.Povrsina();
           Console.WriteLine(max3);
           double max4 = T4.Povrsina();
           Console.WriteLine(max4);

           double[] n = { max1, max2, max3, max4 };
           double MIN = n[0];
           for (int i = 0; i < N; i++)
           {
               if (n[i] <= MIN)
               {
                   MIN = n[i];
               }
           }
           Console.WriteLine(MIN);
       }
   }